/*
 * DelayDWT
 *    STM32,
 *  DWT .
 *
 * void initDelayDwt(void) -  DWT 
 * void delayNs(uint32_t ns) -   
 * void delaySetNs(void) -        
 * void setDelay(uint32_t ns) -   
 * void delayMks(uint32_t mks) -   
 *
 *   .
 *
 * http://mypractic.ru
 */

#include "DelayDWT.h"

//  DWT-
void initDelayDwt(void)
{
    SCB_DEMCR |= CoreDebug_DEMCR_TRCENA_Msk; //  
    DWT_CONTROL |= DWT_CTRL_CYCCNTENA_Msk;   //  
    ticCounter= SystemCoreClock / 1000000; //    1 
}

//  
void delayNs(uint32_t ns)
{
    ticCounter =  ns * (SystemCoreClock / 1000000) / 1000; //  
    DWT->CYCCNT = 0; //  
    while(DWT->CYCCNT < ticCounter);
}

//  
void setDelay(uint32_t ns)
{
    ticCounter =  ns * (SystemCoreClock / 1000000) / 1000; //  
}

//  
void delayMks(uint32_t mks)
{
    ticCounter =  mks * (SystemCoreClock / 1000000); //  
    DWT->CYCCNT = 0; //  
    while(DWT->CYCCNT < ticCounter);
}
