/*
 * DelayDWT
 *    STM32,
 *  DWT .
 *
 * void initDelayDwt(void) -  DWT 
 * void delayNs(uint32_t ns) -   
 * void delaySetNs(void) -        
 * void setDelay(uint32_t ns) -   
 * void delayMks(uint32_t mks) -   
 *
 *   .
 *
 * http://mypractic.ru
 */


/* ,     */
#ifndef DELAYDWT_H
#define DELAYDWT_H

#include "stm32f103xb.h"

#define    DWT_CYCCNT    *(volatile uint32_t *)0xE0001004
#define    DWT_CONTROL   *(volatile uint32_t *)0xE0001000
#define    SCB_DEMCR     *(volatile uint32_t *)0xE000EDFC

void initDelayDwt(void); //  DWT-
void delayNs(uint32_t ns); //   
void setDelay(uint32_t ns); //  
void delayMks(uint32_t mks); //   

uint32_t ticCounter; //  

//  
inline void delaySetNs(void)
{
    DWT->CYCCNT = 0; //  
    while(DWT->CYCCNT < ticCounter);
}


#endif/* DELAYDWT_H */
