/*
 * LCD780
 *   LCD-
 *
 *
 *   .
 *
 * http://mypractic.ru
 */

#ifndef LCD780_H
#define LCD780_H

#include "stm32f103xb.h"

//  ,  rs, en, d4, d5, d6, d7 (,  ),    ,  ,   
void init_LCD( GPIO_TypeDef *GPIOx_RS, uint16_t GPIO_Pin_RS, GPIO_TypeDef *GPIOx_EN, uint16_t GPIO_Pin_EN,
		GPIO_TypeDef *GPIOx_D4, uint16_t GPIO_Pin_D4, GPIO_TypeDef *GPIOx_D5, uint16_t GPIO_Pin_D5,
		GPIO_TypeDef *GPIOx_D6, uint16_t GPIO_Pin_D6, GPIO_TypeDef *GPIOx_D7, uint16_t GPIO_Pin_D7,
		uint8_t col, uint8_t row, uint8_t cirill);

void writeByte_LCD(uint8_t dt); //    LCD

void write_LCD(uint8_t valChar); // //    

void writeBuf_LCD(uint8_t * buf, uint16_t length); //     

void print_uint_LCD(uint32_t n, uint8_t base); //    uint32_t

void print_int_LCD(int32_t n, uint8_t base); //    int32_t

void print_str_LCD(const uint8_t str[]); //  

void print_float_LCD(float number, uint8_t digits); //   float

void clear_LCD(void); //  

void home_LCD(void); //   

void setCursor_LCD(uint8_t col, uint8_t row); //    

void noDisplay_LCD(); //  

void display_LCD(); //  

void noCursor_LCD(); //  

void cursor_LCD(); //  

void noBlink_LCD(); //   

void blink_LCD(); //   

void scrollDisplayLeft_LCD(); //  

void scrollDisplayRight_LCD(); //  

void leftToRight_LCD(); //  

void rightToLeft_LCD(); //  

void autoscroll_LCD(); //  

void noAutoscroll_LCD(); //  

void createChar_LCD(uint8_t location, uint8_t charmap[]); //   


//-------------------------- 

GPIO_TypeDef *_GPIOx_RS; //   RS
uint16_t _GPIO_Pin_RS; //    RS
GPIO_TypeDef *_GPIOx_EN; //   EN
uint16_t _GPIO_Pin_EN; //    EN
GPIO_TypeDef *_GPIOx_D4; //   D4
uint16_t _GPIO_Pin_D4; //    D4
GPIO_TypeDef *_GPIOx_D5; //   D5
uint16_t _GPIO_Pin_D5; //    D5
GPIO_TypeDef *_GPIOx_D6; //   D6
uint16_t _GPIO_Pin_D6; //    D6
GPIO_TypeDef *_GPIOx_D7; //   D7
uint16_t _GPIO_Pin_D7; //    D7
uint8_t _col, _row; //  ,  
uint8_t _cirill;

uint8_t _displaycontrol;
uint8_t _displaymode;

static const uint8_t cirillAsciiTable [] = {
0xc8, 0xc9, 0xca, 0xcb, 0xcc, 0xcd, 0xce, 0xcf,
0xd0, 0xd1, 0xd2, 0xd3, 0xd4, 0xd5, 0xd6, 0xd7,
0xd8, 0xd9, 0xda, 0xdb, 0xdc, 0xdd, 0xde, 0xdf,
0xe7, 0xe8, 0xe9, 0xea, 0xeb, 0xec, 0xed, 0xee,
0xef, 0xf0, 0xf1, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6,
0xa2, 0xf7, 0xf8, 0xf9, 0xfa, 0xfb, 0xfc, 0xfd,
0xfe, 0xff, 0xe7, 0xe8, 0xe9, 0xea, 0xeb, 0xec,
0xb5, 0xee, 0xef, 0xf0, 0xf1, 0xf2, 0xfd, 0xff,
0x41, 0xa0, 0x42, 0xa1, 0xe0, 0x45, 0xa3, 0xa4,
0xa5, 0xa6, 0x4b, 0xa7, 0x4d, 0x48, 0x4f, 0xa8,
0x50, 0x43, 0x54, 0xa9, 0xaa, 0x58, 0xe1, 0xab,
0xac, 0xe2, 0xad, 0xae, 0x62, 0xaf, 0xb0, 0xb1,
0x61, 0xb2, 0xb3, 0xb4, 0xe3, 0x65, 0xb6, 0xb7,
0xb8, 0xb9, 0xba, 0xbb, 0xbc, 0xbd, 0x6f, 0xbe,
0x70, 0x63, 0xbf, 0x79, 0xe4, 0x78, 0xe5, 0xc0,
0xc1, 0xe6, 0xc2, 0xc3, 0xc4, 0xc5, 0xc6, 0xc7 };


#endif/* LCD780_H */
